% standard routine for the interpolation of 2D data
% Adrian Flores Orozco

%clear variables
clear all; close all;

%limits for the color scale
%you can change them
condmin=1; condmax=50;

%reading input file
Z1=dlmread('.\exercise6.txt','',1,0);

% opening a figure with the entire size of the window
figi=figure;
set(figi,'units','normalized','outerposition',[0 0 1 1]);
set(figi, 'Color','white')
axs= axes('Parent',figi); 
axis tight;

% for an interpolation we need to create a grid
    xres = 50;      % number of elements in the x-direction                       
	yres = 50;      % number of elements in the y-direction
    
    %minimum and maximum value for the x- and y-axis
	xmin=min(Z1(:,1)); 	xmax = max(Z1(:,1)); 
	ymin=min(Z1(:,2));     ymax = max(Z1(:,2));
    
    %create the grid
	xx = linspace(xmin, xmax, xres);
	yy = linspace(ymin, ymax, yres);
[XI,YI]=meshgrid(xx, yy);    

%interpolate the conductivity data for the first sensor (column 4)
%interpolation method LINEAR
ZI = griddata(Z1(:,1), Z1(:,2), Z1(:,4), XI,YI,'linear' ); 

%plot the interpolation
hold on
caxis([condmin condmax]);
 	h=imagesc(xx,yy,ZI);    
    set(h, 'alphadata',~isnan(ZI))
    plot(Z1(:,1),Z1(:,2),'w.')
    set(gca,'YDir','normal');
cb=colorbar('ver'); ylabel(cb, 'sigma [mS/m]')
xlim([xmin xmax]); ylim([ymin ymax]);
set(gca,'DataAspectRatio',[1 2 1],'fontsize',8,'TickDir','out')
title( 'linear interpolation','fontsize',12);
hold off